<template>
  <div class="CheatsheetsTab _tabcontent">
    <tab-simple
      v-model="items"
      :is-tab-active="isTabActive"
      :item-title="'L: open with cheatsheet-viewer, R: open in sublime'"
      @leftClick="leftClick"
      @rightClick="rightClick"
      @middleClick="middleClick"
      @create="createItem"
      @onTabActive="onTabActive"
      tab-name="cheatsheets"
      single-item="cheatsheet">
      <template slot="controls" slot-scope="prop">
        <i
          v-if="prop.item.data"
          @click="openFolder(prop.item)"
          class="fa fa-folder"
          aria-hidden="true"
          title="open data">
        </i>
        <i @click="renameItem(prop.item)" class="fa fa-pencil-square-o" aria-hidden="true" title="rename cheatsheet"></i>
        <i @click="deleteItem(prop.item)" class="fa fa-trash" aria-hidden="true" title="delete cheatsheet"></i>
      </template>
    </tab-simple>
  </div>
</template>

<script>
import TabSimple from '@/components/ui/TabBar/TabSimple/TabSimple'

export default {
  components: {
    TabSimple
  },
  data() {
    return {
      items: []
    }
  },
  computed: {
    isTabActive() {
      return this.$parent.active
    },
  },
  mounted() {
    if (this.isTabActive) {
      this.onTabActive()
    }
  },
  methods: {
    async onTabActive() {
      if (!this.items.length) {
        const { data } = await this.$axios.get(`/cheatsheets/get`)
        this.items = data
      }
    },
    leftClick(item) {
      const router = this.$router || $nuxt.$router
      router.push({
        path: '/cheatsheet',
        query: {
          path: path.join(sourcesDir, 'cheatsheets', `${item.name}.md`)
        }
      })
    },
    rightClick(item) {
      this.openInSublime(item, true)
      win.close()
    },
    middleClick(item) {
      this.openInSublime(item, false)
    },
    openInSublime(item, newWin) {
      const command = os.platform() !== 'win32' 
        ? `/bin/bash -c "cd ~/one-punch-web/sources/cheatsheets && subl${newWin ? ' -n' : ''} -a ${item.name}.md"`
        : `cd /d %USERPROFILE%/one-punch-web/sources/cheatsheets && subl${newWin ? ' -n' : ''} -a ${item.name}.md && exit`
      cmd.run(command)
    },
    openFolder(item) {
      const cheatsheetsPath = path.join(os.homedir(), 'one-punch-web', 'sources', 'cheatsheets')
      open(path.join(cheatsheetsPath, 'data', item.name))
      win.close()
    },
    createItem() {},
    renameItem(item) {
      this.$prompt(`Rename "${item.name}" cheatsheet to:`, '', {
        confirmButtonText: 'OK',
        cancelButtonText: 'Cancel',
        inputPattern: /^[^\\\/\:\*\?\"\<\>\|\.]+$/,
        inputErrorMessage: 'Invalid cheatsheet name'
      }).then(async (data) => {
        const newCheatsheetName = data.value
        if (newCheatsheetName && newCheatsheetName !== item.name) {
          const cheatsheetsPath = path.join(os.homedir(), 'one-punch-web', 'sources', 'cheatsheets')
          const renameOldPath = path.join(cheatsheetsPath, item.name + ".md")
          const renameNewPath = path.join(cheatsheetsPath, newCheatsheetName + ".md")
          const cheatsheetsDataPath = path.join(cheatsheetsPath, 'data', item.name)
          fs.renameSync(renameOldPath, renameNewPath)
          let hasData = false
          if (fs.existsSync(cheatsheetsDataPath)) {
            hasData = true
            fs.renameSync(cheatsheetsDataPath, path.join(cheatsheetsPath, 'data', newCheatsheetName))
          }
          const index = _.findIndex(this.items, { name: item.name })
          this.items.splice(index, 1, { name: newCheatsheetName, data: hasData })
        }
      }).catch(e => {})
    },
    deleteItem(item) {
      this.$confirm(`Delete cheatsheet ${item.name}. Continue?`, 'Warning', {
        confirmButtonText: 'OK',
        cancelButtonText: 'Cancel',
        type: 'warning'
      }).then(async () => {
        const cheatsheetsPath = path.join(os.homedir(), 'one-punch-web', 'sources', 'cheatsheets')
        const cheatsheetsDataPath = path.join(cheatsheetsPath, 'data', item.name)
        rimraf.sync(path.join(cheatsheetsPath, `${item.name}.md`))
        if (fs.existsSync(cheatsheetsDataPath)) {
          rimraf.sync(cheatsheetsDataPath)
        }
        const index = _.findIndex(this.items, { name: item.name })
        this.items.splice(index, 1)
      })
    },
  }
}
</script>

<style lang="less" scoped>
@import "./CheatsheetsTab.less";
</style>